Index: DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java	(revision 1286)
+++ DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java	(revision 1299)
@@ -1,6 +1,4 @@
 package example.load;
 
-import schedframe.resources.ResourceStatus;
-import schedframe.resources.computing.Core;
 import schedframe.resources.computing.Processor;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
@@ -13,5 +11,4 @@
 public class ProcessorLoadEstimationPlugin extends BaseLoadEstimationPlugin{
 
-	@Override
 	public double estimateUtlization(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
 		Processor proc = (Processor) resource;
@@ -24,26 +21,18 @@
 		}
 
-		//for(Core core: proc.getCores()){
-			
-			//if(core.getStatus().equals(ResourceStatus.BUSY)){
-				JobRegistry jr = new JobRegistryImpl(proc.getFullName());
-				for(ExecTask task: jr.getRunningTasks()){
-					double cpuUsage = 1 / nrOfThreadsOnCpu;
-					double nrOfThreadsOfApplication = 1;
 
-					for(PhaseBehaviour pb: task.getCurrentResourceConsumption().getBehaviourList()){
-						if(pb.getResouceName().equals("PM_CPU_Usage")){
-							cpuUsage = pb.getUtilization();
-						}
-						if(pb.getResouceName().equals("PM_Threads")){
-							nrOfThreadsOfApplication = pb.getUtilization();
-							break;
-						}
-					}
-					sumCoresLoad = sumCoresLoad + cpuUsage;// * (nrOfThreadsOfApplication / nrOfThreadsOnCpu);
+		JobRegistry jr = new JobRegistryImpl(proc.getFullName());
+		for(ExecTask task: jr.getRunningTasks()){
+			double cpuUsage = 1 / nrOfThreadsOnCpu;
 
+			for(PhaseBehaviour pb: task.getCurrentResourceConsumption().getBehaviourList()){
+				if(pb.getResouceName().equals("PM_CPU_Usage")){
+					cpuUsage = pb.getUtilization();
 				}
-		//	}
-		//}
+			}
+			sumCoresLoad = sumCoresLoad + cpuUsage;
+
+		}
+
 
 		double processorLoad = 100 * sumCoresLoad;	
Index: DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java
===================================================================
--- DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java	(revision 1299)
@@ -2,5 +2,4 @@
 
 
-import example.energy.coolemall.CoolEmAllTestbedMeasurements;
 import gridsim.GridSim;
 import gridsim.dcworms.DCWormsTags;
@@ -36,5 +35,4 @@
 import schedframe.scheduling.tasks.phases.ResourceConsumptionProfile;
 import schedframe.scheduling.tasks.requirements.ResourceParameterName;
-import simulator.stats.implementation.ResourceUsefulWorkStats;
 
 /**
@@ -213,4 +211,19 @@
     		for (ComputingResource resource : pes) {
 
+				LinkedList<ComputingResource> toExamine = new LinkedList<ComputingResource>();
+				toExamine.push(resource);
+
+				while (!toExamine.isEmpty()) {
+					ComputingResource compResource = toExamine.pop();
+					List<ComputingResource> resources = compResource.getChildren();
+					int numberOfRes = resources.size();
+					for (int i = 0; i < numberOfRes; i++) {
+						ComputingResource resourceChild = resources.get(i);
+						trackResource(resourceChild.getFullName());
+						toExamine.addLast(resourceChild);
+					}
+				}
+
+    			
     			trackResource(resource.getFullName());
     			
@@ -477,13 +490,19 @@
 					String productName = resource.getResourceCharacteristic().getParameters().get("product").get(0).getContent();
 					if(productName.equals("Fusion G - T40N"))
-						preparePhases("amdf");
+						preparePhases("Fusion G - T40N");
 					else if(productName.equals("Atom - D510"))
-						preparePhases("atom64");
+						preparePhases("Atom - D510");
 					else if(productName.equals("Atom - N2600"))
-						preparePhases("atom64");
+						preparePhases("Atom - N2600");
 					else if(productName.equals("Core i7 - 2715QE"))
-						preparePhases("i7-2715QE");
+						preparePhases("Core i7 - 2715QE");
 					else if(productName.equals("Core i7 - 3615QE"))
-						preparePhases("i7-3615QE");
+						preparePhases("Core i7 - 3615QE");
+					else if(productName.equals("Xeon E5-2630"))
+						preparePhases("Xeon E5-2630");
+					else if(productName.equals("Xeon E5-2603"))
+						preparePhases("Xeon E5-2603");
+					else if(productName.equals("Xeon L5310"))
+						preparePhases("Xeon L5310");
 				}
 				return true;
Index: DCWoRMS/branches/coolemall/src/gridsim/dcworms/filter/ResourceEventFilter.java
===================================================================
--- DCWoRMS/branches/coolemall/src/gridsim/dcworms/filter/ResourceEventFilter.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/gridsim/dcworms/filter/ResourceEventFilter.java	(revision 1299)
@@ -0,0 +1,44 @@
+package gridsim.dcworms.filter;
+
+import eduni.simjava.Sim_event;
+import gridsim.filter.FilterResult;
+
+/**
+ * @author wojtek
+ *
+ */
+public class ResourceEventFilter extends FilterResult {
+
+	public ResourceEventFilter(int resId, int tag) {
+		super(resId, tag);
+	}
+
+	public boolean match(Sim_event ev) {
+
+		if (ev == null) {
+			return false;
+		}
+
+		boolean result = false;
+		try {
+
+			if (tag_ == ev.get_tag()) {
+				Object obj = ev.get_data();
+
+				if (obj instanceof String) {
+
+					String resId = (String) obj;
+
+					if (resId.hashCode() == eventID_) {
+						result = true;
+					}
+				}
+			}
+		} catch (Exception e) {
+			result = false;
+		}
+
+		return result;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1299)
@@ -21,5 +21,4 @@
 import org.joda.time.DateTimeUtilsExt;
 
-import schedframe.Initializable;
 import schedframe.SimulatedEnvironment;
 import simulator.reader.ResourceReader;
@@ -252,10 +251,15 @@
 		// (default 1)
 		
-		Date date = workload.getSimulationStartTime();
 		Calendar calendar = Calendar.getInstance();
-		if (date == null)
+		if(workload == null){
 			calendar.setTimeInMillis(0L);
-		else
-			calendar.setTime(date);
+		} else {
+			Date date = workload.getSimulationStartTime();
+			if (date == null)
+				calendar.setTimeInMillis(0L);
+			else
+				calendar.setTime(date);			
+		}
+
 
 		boolean traceFlag = true; // means: trace GridSim events/activities
@@ -268,14 +272,15 @@
 		ResourceReader resourceReader = new ResourceReader(
 				options.resdescFileName);
-		SimulatedEnvironment rc = resourceReader.read();
-		eventManager = new EventManager("eventManager", rc);
-		
-		for(Initializable initObj: rc.getToInit()){
+		SimulatedEnvironment simEnv = resourceReader.read();
+		
+		eventManager = new EventManager("eventManager", simEnv);
+		
+		/*for(Initializable initObj: rc.getToInit()){
 			initObj.initiate();
 		}
-		rc.setInitList(null);
+		rc.setInitList(null);*/
 		
 		DCWormsUsers users = new DCWormsUsers("Users",
-				rc.getScheduler().get_name(), workload);
+				simEnv.getScheduler().get_name(), workload);
 		
 		System.out.println("Starting simulation...");
@@ -287,5 +292,5 @@
 
 		DCWormsStatistics stats = new DCWormsStatistics(simulationIdentifier,
-				options, users, statsOutputPath, rc);
+				options, users, statsOutputPath, simEnv);
 		accumulatedStatistics.add(stats);
 		if (log.isInfoEnabled())
@@ -309,18 +314,14 @@
 	private WorkloadLoader loadWorkload(ConfigurationOptions options) throws IOException, MarshalException, ValidationException{
 		XMLJobReader<org.qcg.broker.schemas.jobdesc.Job> xmlJobReader = null;
-		WAReader<org.qcg.broker.schemas.jobdesc.Job> swfReader = null;
+		WAReader<org.qcg.broker.schemas.jobdesc.Job> workloadReader = null;
 
 		String wlFileName = options.inputWorkloadFileName;
 
-		String appProfilesFolder = options.appProfilesFolder;
+		if(wlFileName == null){
+			return null;
+		}
+		
 		if (options.inputFolder != null) {
-			File f = null;
-			if (options.inputTar != null) {
-				f = new File(options.inputFolder + File.separator
-						+ options.inputTar);
-			} else {
-				f = new File(options.inputFolder);
-			}
-
+			File f = new File(options.inputFolder);
 			xmlJobReader = new QcgXmlJobReader(f);
 
@@ -329,7 +330,9 @@
 		}
 
-		swfReader = AbstractWAReader.getInstace(wlFileName);
-
-		WorkloadLoader workload = new WorkloadLoader(xmlJobReader, swfReader, appProfilesFolder);
+		workloadReader = AbstractWAReader.getInstace(wlFileName);
+		
+		String appProfilesFolderName = options.appProfilesFolder;
+		
+		WorkloadLoader workload = new WorkloadLoader(xmlJobReader, workloadReader, appProfilesFolderName);
 		workload.load();
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java	(revision 1299)
@@ -1,455 +1,16 @@
 package simulator.stats;
 
-import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
 import simulator.stats.implementation.MetricsStats;
-import example.energy.coolemall.CoolEmAllTestbedMeasurements;
 
-public class MetricsCalculator {
+public interface MetricsCalculator {
 	
-	protected static final double MILLI_SEC = 1000;
-	protected static final double SEC_IN_HOUR = 3600;
+	public List<MetricsStats> calulateMetrics();
 	
-	protected Map<String, List<GSSAccumulator>> metricsData = new HashMap<String, List<GSSAccumulator>>();
-	protected long timestamp;
-	protected long startTime;
-	protected long endTime;
-
-	public List<MetricsStats> calulateMetrics(long timestamp){
-		this.timestamp = timestamp;
-		List<MetricsStats> metrics = new ArrayList<MetricsStats>();
-		/*for(String resourceTypeName: metricsData.keySet()){
-			MetricsStats metric = new MetricsStats(resourceTypeName, "energyUsage", metricsData.get(resourceTypeName).getMax());
-			metrics.add(metric);}
-		}*/
-		metrics.add(calculateITComputingEnergyConsumption());
-		metrics.add(calculateITEnergyConsumption());
-		metrics.add(calculateNodeGroupFansEnergyConsumption());
-		
-		metrics.add(calculateRackEnergyConsumption());
-		metrics.add(calculateDataCenterFansEnergyConsumption());
-		metrics.add(calculateCoolingDeviceEnergyConsumption());
-		metrics.add(calculateOtherDevicesEnergyConsumption());
-		
-		metrics.add(calculateTotalEnergyConsumption());
-		
-		metrics.add(calculateMeanRackPower());
-		metrics.add(calculateMeanPower());
-		metrics.add(calculateMaxRackPower());
-		metrics.add(calculateMaxPower());
-		
-		metrics.add(calculatePUE());
-		metrics.add(calculatePUELevel4());
-		metrics.add(calculateEnergyWasteRate());
-		
-		metrics.add(calculateUsefulWork());
-		metrics.add(calculateProductivity());
-
-		return metrics;
-	}
+	public void addMetricsData(String resourceTypeName, GSSAccumulator resourceEnergyAccumulator);
 	
-	public void addMetricsData(String resourceTypeName, GSSAccumulator resourceEnergyAccumulator){
-		List<GSSAccumulator> resourceEnergyAccumulatorList = metricsData.get(resourceTypeName);
-		if(resourceEnergyAccumulatorList == null){
-			resourceEnergyAccumulatorList = new ArrayList<GSSAccumulator>();
-		}
-		resourceEnergyAccumulatorList.add(resourceEnergyAccumulator);
-		metricsData.put(resourceTypeName, resourceEnergyAccumulatorList);
-	}
+	public Map<String, List<GSSAccumulator>> getMetricsData();
 	
-	public Map<String, List<GSSAccumulator>> getMetricsData(){
-		return metricsData;
-	}
-	
-	private MetricsStats calculateTotalEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
-				roomPower = roomPower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_energy_consumption", roomPower, timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_energy_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateITComputingEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_processors_energy_consumption", (itComputingPower), timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_processors_energy_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateITEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double totalSitePower = 0; 
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				totalSitePower = totalSitePower + acc.getSum();
-			}
-			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
-				nodeComputingPower = nodeComputingPower+ acc.getSum();
-			}
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			double fanPowerConumspion = nodeComputingPower - itComputingPower;
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_IT_energy_consumption", (totalSitePower * CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY - fanPowerConumspion), timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_IT_energy_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateNodeGroupFansEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
-				nodeComputingPower = nodeComputingPower+ acc.getSum();
-			}
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_node_group_fans_energy_consumption", nodeGroupFansPowerConumspion, timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_node_group_fans_energy_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculatePUELevel4(){
-		
-		MetricsStats metric;
-		try{
-			
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
-				roomPower = roomPower + acc.getSum();
-			}
-			
-			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				totalSitePower = totalSitePower + acc.getSum();
-			}
-			
-		
-			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
-				nodeComputingPower = nodeComputingPower+ acc.getSum();
-			}
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
-
-			metric = new MetricsStats("CoolEmAllTestbed", "PUE_Level_4", roomPower/(totalSitePower * CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY - nodeGroupFansPowerConumspion), timestamp, "");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "PUE_Level_4", -1, timestamp, "");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculatePUE(){
-		
-		MetricsStats metric;
-		try{
-			
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
-				roomPower = roomPower + acc.getSum();
-			}
-			
-			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				totalSitePower = totalSitePower + acc.getSum();
-			}
-
-
-			metric = new MetricsStats("CoolEmAllTestbed", "PUE", roomPower/totalSitePower, timestamp, "");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "PUE", -1, timestamp, "");
-		}
-		return metric;
-	}
-
-	private MetricsStats calculateUsefulWork(){
-		
-		MetricsStats metric;
-		try{
-			double usefulWork = 0;
-			for(String key: metricsData.keySet()){
-				if(key.contains("/")){
-					for(GSSAccumulator acc: metricsData.get(key)){
-						usefulWork= usefulWork + acc.getSum();
-					}
-				}
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Useful_Work", usefulWork, timestamp, "UW units");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Useful_Work", -1, timestamp, "UW units");
-		}
-		
-		return metric;
-	}
-	
-	private MetricsStats calculateProductivity(){
-		
-		MetricsStats metric;
-		try{
-			double usefulWork = 0;
-			for(String key: metricsData.keySet()){
-				if(key.contains("/")){
-					for(GSSAccumulator acc: metricsData.get(key)){
-						usefulWork= usefulWork + acc.getSum();
-					}
-				}
-			}
-			double totalSitePower = 0; 
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				totalSitePower = totalSitePower + acc.getSum();
-			}
-			
-			metric = new MetricsStats("CoolEmAllTestbed", "Productivity", usefulWork/totalSitePower, timestamp, "UW units/Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Productivity", -1, timestamp, "UW units/Wh");
-		}
-		
-		return metric;
-	}
-	
-	
-	private MetricsStats calculateMaxRackPower(){
-		
-		MetricsStats metric;
-		try{
-			double maxPower = 0;
-			
-			for(GSSAccumulator acc: metricsData.get("Rack_MAX")){
-				maxPower = maxPower + acc.getSum();
-			}
-
-			metric = new MetricsStats("CoolEmAllTestbed", "Max_rack_power", maxPower, timestamp, "W");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Max_rack_power", -1, timestamp, "W");
-		}
-		
-		return metric;
-	}
-	
-	private MetricsStats calculateMaxPower(){
-		
-		MetricsStats metric;
-		try{
-			double maxPower = 0;
-			
-			for(GSSAccumulator acc: metricsData.get("Room_MAX")){
-				maxPower = maxPower + acc.getSum();
-			}
-
-			metric = new MetricsStats("CoolEmAllTestbed", "Max_power", maxPower, timestamp, "W");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Max_power", -1, timestamp, "W");
-		}
-		
-		return metric;
-	}
-	
-	private MetricsStats calculateDataCenterFansEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double inletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Inlet")){
-				inletsPower = inletsPower + acc.getSum();
-			}
-			
-			double outletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Outlet")){
-				outletsPower = outletsPower + acc.getSum();
-			}
-			
-			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
-				nodeComputingPower = nodeComputingPower+ acc.getSum();
-			}
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
-			
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_data_center_fans_energy_consumption", (inletsPower + outletsPower - nodeGroupFansPowerConumspion), timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_data_center_fans_energy_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	
-	private MetricsStats calculateRackEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				roomPower = roomPower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_rack_energy_consumption", roomPower, timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_rack_device_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateCoolingDeviceEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double coolingDevicePower = 0;
-			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
-				coolingDevicePower = coolingDevicePower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_cooling_device_energy_consumption", coolingDevicePower, timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_cooling_device_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateOtherDevicesEnergyConsumption(){
-		
-		MetricsStats metric;
-		try{
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
-				roomPower = roomPower + acc.getSum();
-			}
-			
-			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				totalSitePower = totalSitePower + acc.getSum();
-			}
-			
-			double coolingDevicePower = 0;
-			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
-				coolingDevicePower = coolingDevicePower + acc.getSum();
-			}
-			
-			double inletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Inlet")){
-				inletsPower = inletsPower + acc.getSum();
-			}
-			
-			double outletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Outlet")){
-				outletsPower = outletsPower + acc.getSum();
-			}
-			
-			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
-				nodeComputingPower = nodeComputingPower+ acc.getSum();
-			}
-			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
-				itComputingPower = itComputingPower + acc.getSum();
-			}
-			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
-			
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_other_devices_energy_consumption", roomPower - (totalSitePower + coolingDevicePower + (inletsPower + outletsPower - nodeGroupFansPowerConumspion)), timestamp, "Wh");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Total_other_devices_consumption", -1, timestamp, "Wh");
-		}
-		return metric;
-	}
-
-	
-	private MetricsStats calculateMeanPower(){
-		
-		MetricsStats metric;
-		try{
-			
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
-				roomPower = roomPower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Mean_power", roomPower/((this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC)), timestamp, "W");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Mean_power", -1, timestamp, "W");
-		}
-		return metric;
-	}
-	
-	
-	private MetricsStats calculateMeanRackPower(){
-		
-		MetricsStats metric;
-		try{
-			
-			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
-				roomPower = roomPower + acc.getSum();
-			}
-			metric = new MetricsStats("CoolEmAllTestbed", "Mean_rack_power", roomPower/((this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC)), timestamp, "W");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Mean_rack_power", -1, timestamp, "W");
-		}
-		return metric;
-	}
-	
-	private MetricsStats calculateEnergyWasteRate(){
-		
-		MetricsStats metric;
-		try{
-			double itComputingEnergy = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor_CALC")){
-				itComputingEnergy = itComputingEnergy + acc.getSum();
-			}
-			itComputingEnergy = itComputingEnergy + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION * (this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC);
-			double itEnergy = calculateITEnergyConsumption().getValue();
-			
-			metric = new MetricsStats("CoolEmAllTestbed", "Energy_waste_rate", (1 - itComputingEnergy/itEnergy) * 100, timestamp, "%");
-		} catch (Exception e){
-			metric = new MetricsStats("CoolEmAllTestbed", "Energy_waste_rate", -1, timestamp, "%");
-		}
-		return metric;
-	}
-	
-	public long getStartTime() {
-		return startTime;
-	}
-
-	public void setStartTime(long startTime) {
-		this.startTime = startTime;
-	}
-
-	public long getEndTime() {
-		return endTime;
-	}
-
-	public void setEndTime(long endTime) {
-		this.endTime = endTime;
-	}
 }
Index: DCWoRMS/branches/coolemall/src/simulator/stats/AbstractMetricsCalculator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/AbstractMetricsCalculator.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/AbstractMetricsCalculator.java	(revision 1299)
@@ -0,0 +1,43 @@
+package simulator.stats;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import simulator.stats.implementation.MetricsStats;
+
+public abstract class AbstractMetricsCalculator implements MetricsCalculator{
+	
+	protected static final double MILLI_SEC = 1000;
+	protected static final double SEC_IN_HOUR = 3600;
+	
+	protected Map<String, List<GSSAccumulator>> metricsData = new HashMap<String, List<GSSAccumulator>>();
+
+	protected long startTime;
+	protected long endTime;
+	protected long timestamp;
+	
+	public AbstractMetricsCalculator(long startTime, long endTime, long timestamp) {
+		super();
+		this.startTime = startTime;
+		this.endTime = endTime;
+		this.timestamp = timestamp;
+	}
+	
+	abstract public List<MetricsStats> calulateMetrics();
+	
+	public void addMetricsData(String resourceTypeName, GSSAccumulator resourceEnergyAccumulator){
+		List<GSSAccumulator> resourceEnergyAccumulatorList = metricsData.get(resourceTypeName);
+		if(resourceEnergyAccumulatorList == null){
+			resourceEnergyAccumulatorList = new ArrayList<GSSAccumulator>();
+		}
+		resourceEnergyAccumulatorList.add(resourceEnergyAccumulator);
+		metricsData.put(resourceTypeName, resourceEnergyAccumulatorList);
+	}
+	
+	public Map<String, List<GSSAccumulator>> getMetricsData(){
+		return metricsData;
+	}
+
+}
